#!/bin/sh

set -ex


# Arguments to this script:
# - $1 : the name of the package
# - $2 : the full name of the toolchain to use to build everything


PACKAGE_NAME=$1
TOOLCHAIN_VERSION="11.2.0"



# Assumptions:
# - busybox is installed in /opt, which basically assumes we are running on Axiom
# - hutchr is installed and in the PATH

# bundles installs are always done in /opt/$PACKAGE_NAME-bundle, there is currently no direct support for anything else because there is no use case at the moment
bundleinstalldirectory=/opt/$PACKAGE_NAME-bundle


# start an empty hutch

mkdir -p $PACKAGE_NAME"_hutch/filesystem layout"
mkdir -p $PACKAGE_NAME"_hutch/filesystem layout/etc"   # TODO: update hutchr to remove this
mkdir -p $PACKAGE_NAME"_hutch/filesystem layout/opt"   # TODO: update hutchr to remove this
mkdir -p $PACKAGE_NAME"_hutch/filesystem layout/tmp"   # TODO: update hutchr to remove this
hutchr run --uid0 --bind-ro /opt/busybox "$PACKAGE_NAME"_hutch /opt/busybox/bin/sh -c "$(cat << EOF

set -ex

# prepare inside the hutch for the build

export PATH=/bin:/opt/busybox/bin
mkdir -p /bin
ln -svf /opt/busybox/bin/* /bin/


cd /home/me/Documents/ports   # TODO: this may not be the correct location
./install\ gcc\ toolchain.sh $TOOLCHAIN_VERSION

mkdir -p /opt/$PACKAGE_NAME-bundle/lib/
cp /lib/*.so* /opt/$PACKAGE_NAME-bundle/lib/

export ORIGIN='\$ORIGIN'   # if any shell tries to substitute $ORIGIN (who knows how many nested shells can be run recursively), then we end up with $ORIGIN anyway
export LDFLAGS='-Wl,-rpath=\$ORIGIN/../../lib -Wl,--dynamic-linker=/opt/$PACKAGE_NAME-bundle/lib/ld-musl-x86_64.so.1'   # these flags will allow finding the dynamic loader and the C++ libraries at run time, provided that we are in the binaries of the package are in $package_fullname/bin/

./packageinstall.sh $PACKAGE_NAME --prefix $bundleinstalldirectory

EOF
)"


mv "$PACKAGE_NAME"_hutch/"filesystem layout/$bundleinstalldirectory" /opt/
ln -svf $bundleinstalldirectory/$PACKAGE_NAME/bin/* /bin/



# clean up
rm -r "$PACKAGE_NAME"_hutch
