package_name=argp-standalone
package_version=1.3
tarball_suffix=gz
build_dependencies="automake autoconf"   # because we reconfigure




# This is presumably only used by elfutils

# patches are taken from Alpine aports



custombuild(){
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory
	
	
	for p in ../../packages/extended/$package_name/*.patch; do
		patch -p1 < $p
	done
	
	autoreconf -vif
	
	export CFLAGS="-fPIC"   # needed for linking against libarp.a
	
	
	./configure --prefix=$installdirectory/$package_fullname
		
	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	if test -z $no_check   # run the make check, unless $no_check is set for this package definition
	then make -j$ncpu check || make -j$ncpu test
	fi
	
	
	# this doesn't install anything, so we do it ourselves
	
	mkdir -p $installdirectory/$package_fullname/include
	mkdir -p $installdirectory/$package_fullname/lib
	cp argp.h $installdirectory/$package_fullname/include/
	cp libargp.a $installdirectory/$package_fullname/lib
	ln -svf $installdirectory/$package_fullname $installdirectory/$package_name
	
	
	# NOTE: .m4 files should probably be installed as well by default, but i have no strong opinion on it, so for now we leave this to the postinstall() function
	cd ../..
	rm -r $builddir
}
