package_name=bluez-alsa
package_version=2.0.0
tarball_suffix=gz
build_dependencies="sbc alsa-lib bluez glib dbus"   # but dbus not needed if bluealsa-aplay is not built



# need to put the pkg-config file of dbus back, just for the build
# this file was removed, to avoid other apps to find and rely on dbus, which is not necessarily running on the system
ln -svf /opt/dbus/lib/pkgconfig/dbus-1.pc /opt/pkgconf/lib/pkgconfig/


# the binaries don't have these --rpath
# TODO: libtool can't figure these out because they are transitive dependencies?
export LDFLAGS="-Wl,-rpath,$installdirectory/ncurses/lib -Wl,-rpath,$installdirectory/readline/lib"



# NOTE: because our dbus is "hidden" from the public, you need to provide the correct address before running the bluealsa service, by DBUS_SYSTEM_BUS_ADDRESS
# NOTE: to play with any software with alsa-lib 1.1.2, bluez-alsa mandates the environment variable LIBASOUND_THREAD_SAFE=0, so this will become a global environment variable. version 1.1.9 does not have this problem



# NOTE: the org.bluealsa is not allowed via dbus, and adequate permissions must be added to our dbus configuration file. Same permissions as in bluealsa.conf bluetooth configuration file installed by the bluealsa package into /opt/dbus/etc/dbus-1/system.d/.  But this file is not sourced by dbus, so we add these permissions ourselves. We do that in our bluez package, the configuration file provided there (bluez_bluetooth.conf) already provides the adequate permissions for bluealsa, for root and jerry users.



postinstall() {
	
	# link the bluealsa alsa configuration file
	ln -svf /opt/bluez-alsa/etc/alsa/conf.d/20-bluealsa.conf /opt/alsa-lib/share/alsa/alsa.conf.d/
	
	
	# clean up: remove the dbus pkgconfig file that we added
	rm /opt/pkgconf/lib/pkgconfig/dbus-1.pc
}




# to run bluealsa, you need to export the dbus socket path:
#export DBUS_SYSTEM_BUS_ADDRESS=unix:path=/var/run/bluez/system_bus_socket
