package_name="cups"
package_version="2.2.6"
tarball_suffix=gz
build_dependencies="zlib"


custombuild() {
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory

	./configure --prefix=/opt/$package_name-$package_version --disable-dbus

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	make install

	ln -sv /opt/$package_name-$package_version /opt/$package_name || true
	ln -sv /$package_name-$package_version/bin/* /bin/ || true

	if [ -d "/opt/$package_name-$package_version/lib/pkgconfig" ]; then
		ln -svf /opt/$package_name-$package_version/lib/pkgconfig/* /opt/pkgconf/lib/pkgconfig
	fi

	cd ../..
	rm -r builddir
}
