#!/bin/sh -ex

# This script builds modified libsecret for com.skype.CLient, to allow user credential store/load
# form a file in flatpak hutch file system

# IMPORTANT: Normally this script is invoked by "build all application fixes.sh", which exports
#            3 env vars, $BUILDDIR, and $OUTPUT $BUILDHOST. If you intentd to use it outside this scope
#            define these variables manually

# Warn used if these variables are missing
if [ "$BUILDDIR" = "" ] || [ "$OUTPUT" = "" ] || [ "$BUILDHOST" = "" ]; then
    echo "Define BUILDDIR, OUTPUT and BUILDHOST env variables"
    exit
fi

# clean any prevous contents
cd $BUILDDIR
rm -rf hutchr

# TODO: don't use ssh, use https instead
# for now we have to enter pass manually
# clone hutchr repository, this is where we keep modified libsecret sources
git clone ssh://robotbuilder@git.cacaoweb.org:/var/git/hutchr.git

cd "hutchr/hutchr applications/utilities/libsecret/"
./build.sh

# TODO: get fix path automatically, by searching matching file inside sandbox /app folder
mkdir -p "$OUTPUT/lib"
cp *.so* "$OUTPUT/lib"

# cleanup
cd $BUILDDIR
rm -rf hutchr
