# Firefox pulseaudio issues

## Two video playing in parallel

Playing two videos in two firefox tabs, most likely will lead to unpleasant audio glitches.
Glitches can appear as one video crackling and speeding up to to point of preload contents. It typically happens when user make a jump in other video.

With pulseaudio, we can try to improve glitch behavior with `tsched` parameter, in the `/home/jerry/.opt/hutches/flatpak/filesystem layout/pulseaudio/filesystem layout/opt/pulseaudio-13.99.1/etc/pulse/default.pa`

`tsched=1` is defined by default, and gives a bit better performance on the Tassig box and, but it won't prevent glitches to occur, they are just less unpleasant. This is precise timer based, improved schedulig, used since 0.9.11 pulseaudio.

`tsched=0` is currenty used in production flatpak hutch, and lesds to worse glitch situation, compared to value of 1. This is older interrupt based scheduling.

Good portion of explanation about this issue can be found here:
[https://wiki.archlinux.org/index.php/PulseAudio/Troubleshooting#Glitches.2C_skips_or_crackling]  under `Glitches, skips or crackling`


## One video form firefox

Only one video playback runs without any issues.

## One video form firefox, playing in parallel with other audio outside firefox

Interesting fact, if only one video plays form firefox, and many other plays form other sources, this won't lead to issues, or very rare small audio chunk skip, while user change focus to other apps.

Test was done with one video playing in `firefox`, two videos playing in parallel with `tassig-internet` and one video file playing form flatpak based `vlc`


Conclusion is that this is either `firefox` or flatpak hutched `pulseaudio`, and not directly related to `alsa` or kernel drivers.


## flatpak firefox test with Ubuntu 19.08

With Ubuntu, flatpak-1.0.8, and firefox 76.0.1, there is no audio issues with more than one video plays form firefox. We have tested 3 videos in parallel, and it went fine.

This seems has nothing to do with flatpak version, but with pulseaudio packed with Axiom flatpak hutch.


## flatpak firefox, hutchr based, test with Ubuntu 19.08

We can check the difference between ubuntu provided flatpak, and hutchr provided flatpak-1.8.2. In this setup, hutchr will use host pulseaudio server, so this is a good test to check if flatpak provided `pulseaudio` hutch is the culprit with glitches.

Audio issues don't occur, using host pulseaudio.


CONCLUSION 1: Up to now we can make a conclusion, flatpak provided pulseaudio is the culprit with the issue we described above.



## flatpak firefox using alsa directly with Ubuntu 19.08

In this setup, we use Tassig Box with Ubuntu 19.08, with pulseaudio server disabled, and with Axiom alsa configuration file, produced on the box, with Axiom audio config generator.

We want to check that firefox issue has nothing to do with host alsa installation.

First, make a copy of `/etc/pulse/client.conf` to `/etc/pulse/client.conf.orig`. We have to edit `/etc/pulse/client.conf`, to prevent pulseserver of being started automatically. These two lines should be uncommened and edited like this:

```
autospawn = no
daemon-binary = /bin/true
```

Second, we have to alter Ubuntu alsa configuration, by temporary moving `/usr/share/alsa/alsa.conf.d` into `/usr/share/alsa/alsa.conf.d.orig`, anf creating new empty `/usr/share/alsa/alsa.conf.d`

Take `/var/etc/asla/virtual_sound_card_config.conf`, form the box with Axiom installation, and copy to the box with Ubuntu installation, to `/usr/share/alsa/alsa.conf.d`. This way we ensure now Ubuntu use same sound setup as Axiom, and alsa config file will be propagated to `flatpak` and `pulseaudio` hutches.

Now if we run `hutchr org.mozilla.firefox`, it will use flatpak provided pulse server, but internally, pulse server will use alsa, which uses Axiom config file.

In this setup, same firefox issues appear, audio has lot of issues, with two videos playing in parallel.

Finally, revert back changes done in Ubuntu host, `/etc/pulse/client.conf` and `/usr/share/alsa/alsa.conf.d`
