# Spotify issues

# Audio playback issue

We can observe 3 TYPES of how playing song issues appears, once we click on Play:

  1) Song plays 3-4s, and then message appears "Can't play current song"
  2) Songs appears playing, timer is counting, but no sound from the beginning, no messages appeart
  3) Song don't start at all, counter is 0:00, and no messages appears 


Something similar was mentioned in this flatpak Spotify issues thread:
[https://github.com/flathub/com.spotify.Client/issues/90]. 


We can suspect on alsa/dmix related issues, which is related to other apps run audio in parallel with Spotify, but for now there is no direct relation.  NOTE: we provide our own compiled alsa-lib, as `runtime fixes`. All the details are available in the document `runtime fixes.md`. However, alsa samples works fine in Spotify sandbox, with/without host playback. 


Next section with tests can give more hints, is this issue purely Sporify bug, or is related to alsa/dmix. 

## Test 1

In this test we use Soptify with and without any other audio playback.

Current flatpak version of spotify under test is:

`e70bce760efe14e6097c54be884903f8b8e9ab2e6872a46da10348c18feb9582`


### Test A: Playback host, tassig internet and youtube

  * Tommy Guerrero - Road to Nowhere: 
    * Songs 1-6 plays fine
    * Songs 7,8,9 and 11,12 won't play, TYPE 3
    * then after playing some songs randomly, song 7 and 8 will start, but ends up TYPE 1
    * but little bit after, song 8 plays fully, and next time it end up TYPE 3

    This is not consisten and repeatable behavior.

### Test B: Close Spotify, cloded host playback tassig internet, restart Spotify

I have restarted Spotify 3 times, but the exact same issues appeared. Songs 7,8,9,11 and 12, won't work, all other works fine.


### Test C: Reboot Axiom, start spotify without any other playback

Test was done 3 times, same issues as before. Songs 7,8,9,11 and 12, won't work, all other works fine.


CONCLUSION: Songs which won't play behaeves the same with and without other playback. Restarting Spotify or Axiom host, has no effect. Always the same songs are affected.


## Test 2

Spotify can be used with command line parameter "--show-console", which prints lot of debugging information. To add it, we have to edit file `/home/jerry/.opt/hutches/flatpak/filesystem layout/opt/flatpak-1.4.3/var/lib/flatpak/app/com.spotify.Client/x86_64/stable/active/files/bin/spotify`

Normal song play:

```
13:01:58.149 I [audio_session.cpp:532           ] Close track (playback_id 015039dea84e98775ffd881234cebc0e)
13:01:58.149 I [audio_session.cpp:533           ]     source_end: album
13:01:58.149 I [audio_session.cpp:534           ]     reason_end: endplay
13:01:58.152 I [logger_impl_base.cpp:63         ] Saved 1 log messages to '/home/me/.var/app/com.spotify.Client/config/spotify/Users/kk75omeyt5znucyvyunivs3z3-user/log-tracked'
13:01:58.153 I [logger_impl_base.cpp:63         ] Saved 1 log messages to '/home/me/.var/app/com.spotify.Client/config/spotify/Users/kk75omeyt5znucyvyunivs3z3-user/log-tracked'
13:01:58.153 I [connectivity_manager.cpp:273    ] Playing music set to 'false'
13:01:58.153 I [connectivity_manager.cpp:111    ] Scheduling emission of signal.
13:01:58.154 I [sliding_window_prefetch_strategy.cpp:232] Prefetch: looks like new context - resetting window size to 1
13:01:58.158 I [connectivity_manager.cpp:102    ] Emitting signal.
13:01:58.194 I [audio_session.cpp:235           ] Creating track player for track (playback_id 014c14c40a30cfef9ebcdd19981636d9)
13:01:58.194 I [audio_session.cpp:236           ]     track_uri: spotify:track:3EhuEeTQP2tAICvTakOEYF
13:01:58.194 I [audio_session.cpp:237           ]     speed: 1.000000
13:01:58.194 I [audio_session.cpp:238           ]     normalization: album
13:01:58.194 I [audio_session.cpp:239           ]     stream_type: default
13:01:58.194 I [audio_session.cpp:240           ]     urgency: now
13:01:58.194 I [audio_session.cpp:241           ]     track_select_flag: 0
13:01:58.194 I [karaoke_audio_sink_factory.cpp:68] karaoke: No flags enabled
13:01:58.195 I [audio_session.cpp:266           ] Open track player (playback_id 014c14c40a30cfef9ebcdd19981636d9)
13:01:58.195 I [audio_session.cpp:267           ]     position: 0 ms
13:01:58.195 I [audio_session.cpp:268           ]     paused: false
13:01:58.195 I [audio_session.cpp:269           ]     transition: none
13:01:58.195 I [head_file_streamer.cpp:198      ] Requesting head file from CDN url: https://heads-fa.scdn.co/head/eb00bd71e14dfaafb40872e2d60dc3b1dcd18554 
13:01:58.195 I [audio_player_queue_entry.cpp:255] Entry (0x00007f2b502fa888) is buffering
13:01:58.195 I [audio_player_queue_impl.cpp:290 ] Created entry (0x00007f2b502fa888) for player in AudioPlayerQueue
13:01:58.195 I [audio_player_queue_impl.cpp:291 ]     stream type: default
13:01:58.195 I [audio_player_queue_impl.cpp:292 ]     paused: false
13:01:58.195 I [audio_player_queue_impl.cpp:293 ]     transition: none
13:01:58.195 I [audio_player_queue_impl.cpp:294 ]     fade in start: -1 ms
13:01:58.195 I [audio_player_queue_impl.cpp:295 ]     fade in duration: -1 ms
13:01:58.195 I [audio_player_queue_impl.cpp:296 ]     fade out start: -1 ms
13:01:58.195 I [audio_player_queue_impl.cpp:297 ]     fade out duration: -1 ms
13:01:58.199 I [connectivity_manager.cpp:273    ] Playing music set to 'true'
13:01:58.199 I [connectivity_manager.cpp:111    ] Scheduling emission of signal.
13:01:58.252 I [sliding_window_prefetch_strategy.cpp:232] Prefetch: looks like new context - resetting window size to 1
13:01:58.258 I [connectivity_manager.cpp:102    ] Emitting signal.
13:01:58.290 I [libvorbis_ogg_decompressor.cpp:401] track gain: (-7.77Db), track peak: (1.12943dB), album gain: (-9.04dB), album peak: (1.15226dB), normalization: albumgain
13:01:58.291 I [audio_decompressor_process.cpp:218] Opening sink for playback.
13:01:58.291 I [audio_decompressor_process.cpp:219]     codec: vorbis
13:01:58.291 I [audio_decompressor_process.cpp:220]     bitrate: 160000 bits/s
13:01:58.291 I [audio_decompressor_process.cpp:221]     sample rate: 44100 Hz
13:01:58.291 I [audio_decompressor_process.cpp:222]     channels: 2
13:01:58.291 I [audio_decompressor_process.cpp:223]     sample format: 16-bit-pcm
13:01:58.291 I [audio_decompressor_process.cpp:224]     duration: 179981 ms
13:01:58.296 I [audio_decompressor_process.cpp:506] Starting playback.
13:01:58.296 I [audio_decompressor_process.cpp:507]     min limit 4000 ms.
13:01:58.296 I [audio_decompressor_process.cpp:508]     compressed buffer: 75580 bytes
13:01:58.296 I [audio_decompressor_process.cpp:509]     decompressed buffer: 0 ms
13:01:58.296 I [audio_decompressor_process.cpp:511]     sink buffer: 1021 ms
13:01:58.296 I [audio_decompressor_process.cpp:512]     final source buffer: false
13:01:58.296 I [audio_player_queue_entry.cpp:255] Entry (0x00007f2b502fa888) is not buffering
13:01:58.301 I [audio_streamer.cpp:981          ] Encrypted data 64k-latency: 2 ms. Play latency: 103 ms
13:02:03.254 I [sliding_window_prefetch_strategy.cpp:117] Prefetch window maxed and full, waiting for 0 track changes
13:02:03.254 I [sliding_window_prefetch_strategy.cpp:333] Prefetch: canceling previous download for file : 7ebcf1fd5cf98e601f67a9a3571b7a2090016935
13:02:03.426 I [sliding_window_prefetch_strategy.cpp:33] Prefetch: key prefetched for track: Highway Hustle (file: 39b1faee8b97ae0bf8e9ac0975d2a4b789f0533f)
13:02:05.009 E [pubsub_subscription.cpp:590     ] aq: LWS got LWS_CALLBACK_CLIENT_WRITEABLE
13:02:05.045 E [pubsub_subscription.cpp:590     ] aq: LWS got LWS_CALLBACK_CLIENT_RECEIVE_PONG
13:02:05.132 I [request_accounting.cpp:416      ] High request latency: https://spclient.wg.spotify.com/ad-logic took 278 ms
```


Failed song, TYPE 3:

```
12:58:41.064 I [request_accounting.cpp:416      ] High request latency: https://spclient.wg.spotify.com/ad-logic took 201 ms
12:58:43.512 I [audio_session.cpp:579           ] Play track (playback_id 015039dea84e98775ffd881234cebc0e)
12:58:43.512 I [audio_player_queue_impl.cpp:825 ] Unpause driver (0x00007f2b501f1c10)
12:58:43.515 I [head_file_streamer.cpp:161      ] Reading head file from cache
12:58:43.518 I [libvorbis_ogg_decompressor.cpp:401] track gain: (-7.4Db), track peak: (1.07963dB), album gain: (-9.04dB), album peak: (1.15226dB), normalization: trackgain
12:58:43.518 I [audio_player_queue_impl.cpp:653 ] Opening driver (0x00007f2b501f1c10)
12:58:43.518 I [audio_player_queue_impl.cpp:654 ]     sample rate: 44100 Hz
12:58:43.518 I [audio_player_queue_impl.cpp:655 ]     channels: 2
12:58:43.518 I [audio_player_queue_impl.cpp:656 ]     sample format: 16-bit-pcm
12:58:43.518 I [audio_player_queue_impl.cpp:657 ]     stream type: default
12:58:43.518 I [audio_player_queue_impl.cpp:658 ]     paused: false
12:58:43.544 I [audio_decompressor_process.cpp:218] Opening sink for playback.
12:58:43.544 I [audio_decompressor_process.cpp:219]     codec: vorbis
12:58:43.544 I [audio_decompressor_process.cpp:220]     bitrate: 160000 bits/s
12:58:43.544 I [audio_decompressor_process.cpp:221]     sample rate: 44100 Hz
12:58:43.544 I [audio_decompressor_process.cpp:222]     channels: 2
12:58:43.544 I [audio_decompressor_process.cpp:223]     sample format: 16-bit-pcm
12:58:43.544 I [audio_decompressor_process.cpp:224]     duration: 193268 ms
12:58:43.545 I [connectivity_manager.cpp:273    ] Playing music set to 'true'
12:58:43.545 I [connectivity_manager.cpp:111    ] Scheduling emission of signal.
12:58:43.570 I [connectivity_manager.cpp:102    ] Emitting signal.
12:58:43.589 I [audio_decompressor_process.cpp:376] Restarting decompressor.
12:58:43.589 I [audio_decompressor_process.cpp:377]     pos: 4762 frames
12:58:43.589 I [audio_decompressor_process.cpp:378]     offset: 4511 bytes
12:58:43.600 I [cdn_chunk_downloader.cpp:134    ] Requesting data (131072 -> 163840) from CDN url: https://audio-akp-bbr-spotify-com.akamaized.net/audio/73f491e82469d8039fd8c614fe565313889031f3?__token__=exp=1587473924~hmac=2e774d7871330899949581d424b9996971de41122497663410ca4b3b5f74bfad 
12:58:43.767 I [cdn_chunk_downloader.cpp:134    ] Requesting data (0 -> 540672) from CDN url: https://audio-akp-bbr-spotify-com.akamaized.net/audio/73f491e82469d8039fd8c614fe565313889031f3?__token__=exp=1587473924~hmac=2e774d7871330899949581d424b9996971de41122497663410ca4b3b5f74bfad 
```


Non woring song has this request, which seems to fail:
```
12:58:43.600 I [cdn_chunk_downloader.cpp:134    ] Requesting data (131072 -> 163840) from CDN url: https://audio-akp-bbr-spotify-com.akamaized.net/audio/73f491e82469d8039fd8c614fe565313889031f3?__token__=exp=1587473924~hmac=2e774d7871330899949581d424b9996971de41122497663410ca4b3b5f74bfad 
```

NOTE: Since we don't get any error code, and we have TYPE 3 issue (playback failure without spotify error message) we can expext we that in case of TYPE 1, we will see error message in the log. TODO


We can test if there is clear difference in CDN request, for songs that works, and the one that does not work, for example 1,2,3 and 7,8,9

NOTE: Clear Spotify cache `/home/jerry/.opt/hutches/flatpak/filesystem layout/home/me/.var/app/com.spotify.Client/cache`

Song 1:

```
13:46:02.272 I [audio_session.cpp:235           ] Creating track player for track (playback_id 01b7cd379b3818746d0093b357a8f9ab)
...
13:46:02.274 I [head_file_streamer.cpp:198      ] Requesting head file from CDN url: https://heads-fa.scdn.co/head/d3c77430aa1c291faa30aaa5fb577e405b9ef384 
13:46:02.274 I [audio_player_queue_entry.cpp:255] Entry (0x00007f89cc98d028) is buffering
...
13:46:02.735 I [cdn_chunk_downloader.cpp:353    ] Request for file d3c77430aa1c291faa30aaa5fb577e405b9ef384 complete (code: success (0))
```

NOTE: While playing Song 1, spotify already tries to pre-fetch Song 2

Song 2:

```
13:46:07.291 I [sliding_window_prefetch_strategy.cpp:181] Prefetch: start prefetching track  White Sands : eb00bd71e14dfaafb40872e2d60dc3b1dcd18554
13:46:07.340 I [cdn_chunk_downloader.cpp:134    ] Requesting data (0 -> 524288) from CDN url: https://audio-sp-fra.spotifycdn.net/audio/eb00bd71e14dfaafb40872e2d60dc3b1dcd18554?1587476768_mR62cFkIjI5T77v18uIUU42xswMTeuiJxh7ARydsVTA= 
13:46:07.456 I [sliding_window_prefetch_strategy.cpp:33] Prefetch: key prefetched for track: White Sands (file: eb00bd71e14dfaafb40872e2d60dc3b1dcd18554)
13:46:07.479 I [cdn_chunk_downloader.cpp:353    ] Request for file eb00bd71e14dfaafb40872e2d60dc3b1dcd18554 complete (code: success (0))
```

Song 3:

```
13:55:49.893 I [sliding_window_prefetch_strategy.cpp:181] Prefetch: start prefetching track  Highway Hustle : 39b1faee8b97ae0bf8e9ac0975d2a4b789f0533f
13:55:50.030 I [sliding_window_prefetch_strategy.cpp:33] Prefetch: key prefetched for track: Highway Hustle (file: 39b1faee8b97ae0bf8e9ac0975d2a4b789f0533f)
13:55:50.030 I [cdn_chunk_downloader.cpp:134    ] Requesting data (0 -> 524288) from CDN url: https://audio-sp-fra.spotifycdn.net/audio/39b1faee8b97ae0bf8e9ac0975d2a4b789f0533f?1587477350_x64o2ips8o2xThAWE861MuIM9MICnRfmbmWVAwRlfsU= 
13:55:55.347 I [request_accounting.cpp:416      ] High request latency: https://audio-sp-fra.spotifycdn.net/audio took 5316 ms
13:55:55.347 I [cdn_chunk_downloader.cpp:353    ] Request for file 39b1faee8b97ae0bf8e9ac0975d2a4b789f0533f complete (code: success (0))
```


CONCLUSIONS:

Spotify first locates head of the playlist at `https://heads-fa.scdn.co/head/` (head_file_streamer.cpp)

Then these 3 songs are being downloaded form `https://audio-sp-fra.spotifycdn.net/audio/`, each one while previous song is playing.


Without more log details, test shows that porblematic Songs 7,8,9,11 and 12 are using different server to access audio data `https://audio-akp-bbr-spotify-com.akamaized.net/audio/`


Now it turns out that some sporify servers works, while some other doesn't. One link that may refer it's related to free account advertisement is [https://gist.github.com/opus-x/3e673a9d5db2a214df05929a4eee6a57]. There we can see 

In case of first non working Song 7, there is no obvious error which is related to the message "Can't play current song". Here is the log:

```
14:12:23.263 I [request_accounting.cpp:416      ] High request latency: https://spclient.wg.spotify.com/ad-logic took 272 ms
14:12:27.445 I [audio_session.cpp:532           ] Close track (playback_id 019d55de76b49042b1c58e876bae9269)
14:12:27.445 I [audio_session.cpp:533           ]     source_end: unknown
14:12:27.445 I [audio_session.cpp:534           ]     reason_end: endplay
14:12:27.446 I [logger_impl_base.cpp:63         ] Saved 1 log messages to '/home/me/.var/app/com.spotify.Client/config/spotify/Users/kk75omeyt5znucyvyunivs3z3-user/log-tracked'
14:12:27.447 I [logger_impl_base.cpp:63         ] Saved 1 log messages to '/home/me/.var/app/com.spotify.Client/config/spotify/Users/kk75omeyt5znucyvyunivs3z3-user/log-tracked'
14:12:27.448 I [sliding_window_prefetch_strategy.cpp:232] Prefetch: looks like new context - resetting window size to 1
14:12:27.448 D [gaia_manager.cpp:874            ] GAIA:   current state ID updated to -1745951472
14:12:27.542 I [audio_session.cpp:235           ] Creating track player for track (playback_id 0148ebb7ca3ff9bf8e434941514485b8)
14:12:27.542 I [audio_session.cpp:236           ]     track_uri: spotify:track:4gvwWBH2sM1nK8Jf0MJNK1
14:12:27.542 I [audio_session.cpp:237           ]     speed: 1.000000
14:12:27.542 I [audio_session.cpp:238           ]     normalization: album
14:12:27.542 I [audio_session.cpp:239           ]     stream_type: default
14:12:27.542 I [audio_session.cpp:240           ]     urgency: now
14:12:27.542 I [audio_session.cpp:241           ]     track_select_flag: 0
14:12:27.543 I [karaoke_audio_sink_factory.cpp:68] karaoke: No flags enabled
14:12:27.543 I [audio_session.cpp:266           ] Open track player (playback_id 0148ebb7ca3ff9bf8e434941514485b8)
14:12:27.543 I [audio_session.cpp:267           ]     position: 0 ms
14:12:27.543 I [audio_session.cpp:268           ]     paused: false
14:12:27.543 I [audio_session.cpp:269           ]     transition: none
14:12:27.543 I [head_file_streamer.cpp:198      ] Requesting head file from CDN url: https://heads-fa.scdn.co/head/73f491e82469d8039fd8c614fe565313889031f3 
14:12:27.543 I [audio_player_queue_entry.cpp:255] Entry (0x00007f89cc774758) is buffering
14:12:27.543 I [audio_player_queue_impl.cpp:290 ] Created entry (0x00007f89cc774758) for player in AudioPlayerQueue
14:12:27.543 I [audio_player_queue_impl.cpp:291 ]     stream type: default
14:12:27.543 I [audio_player_queue_impl.cpp:292 ]     paused: false
14:12:27.543 I [audio_player_queue_impl.cpp:293 ]     transition: none
14:12:27.543 I [audio_player_queue_impl.cpp:294 ]     fade in start: -1 ms
14:12:27.543 I [audio_player_queue_impl.cpp:295 ]     fade in duration: -1 ms
14:12:27.543 I [audio_player_queue_impl.cpp:296 ]     fade out start: -1 ms
14:12:27.543 I [audio_player_queue_impl.cpp:297 ]     fade out duration: -1 ms
14:12:27.543 I [audio_player_queue_impl.cpp:825 ] Unpause driver (0x00007f89ccf07a80)
14:12:27.546 I [connectivity_manager.cpp:273    ] Playing music set to 'true'
14:12:27.546 I [connectivity_manager.cpp:111    ] Scheduling emission of signal.
14:12:27.561 I [sliding_window_prefetch_strategy.cpp:232] Prefetch: looks like new context - resetting window size to 1
14:12:27.563 D [gaia_manager.cpp:874            ] GAIA:   current state ID updated to -1745951358
14:12:27.568 I [connectivity_manager.cpp:102    ] Emitting signal.
14:12:27.589 E [dial_discovery.cpp:413          ] Operation canceled
14:12:27.589 E [dial_discovery.cpp:413          ] Operation canceled
14:12:27.688 I [libvorbis_ogg_decompressor.cpp:401] track gain: (-7.4Db), track peak: (1.07963dB), album gain: (-9.04dB), album peak: (1.15226dB), normalization: albumgain
14:12:27.688 I [audio_decompressor_process.cpp:218] Opening sink for playback.
14:12:27.688 I [audio_decompressor_process.cpp:219]     codec: vorbis
14:12:27.688 I [audio_decompressor_process.cpp:220]     bitrate: 160000 bits/s
14:12:27.688 I [audio_decompressor_process.cpp:221]     sample rate: 44100 Hz
14:12:27.688 I [audio_decompressor_process.cpp:222]     channels: 2
14:12:27.688 I [audio_decompressor_process.cpp:223]     sample format: 16-bit-pcm
14:12:27.688 I [audio_decompressor_process.cpp:224]     duration: 193268 ms
14:12:27.690 I [cdn_chunk_downloader.cpp:134    ] Requesting data (0 -> 524288) from CDN url: https://audio-akp-bbr-spotify-com.akamaized.net/audio/73f491e82469d8039fd8c614fe565313889031f3?__token__=exp=1587478348~hmac=2167a16aa4b7fe3875fd03ed81ba2b747b9ee64634efa04072655defdfcd3ac6 
14:12:27.709 D [gaia_manager.cpp:874            ] GAIA:   current state ID updated to -1745951211
14:12:27.725 I [audio_decompressor_process.cpp:506] Starting playback.
14:12:27.725 I [audio_decompressor_process.cpp:507]     min limit 2200 ms.
14:12:27.725 I [audio_decompressor_process.cpp:508]     compressed buffer: 4078 bytes
14:12:27.725 I [audio_decompressor_process.cpp:509]     decompressed buffer: 0 ms
14:12:27.725 I [audio_decompressor_process.cpp:511]     sink buffer: 2007 ms
14:12:27.725 I [audio_decompressor_process.cpp:512]     final source buffer: false
14:12:27.725 I [audio_player_queue_entry.cpp:255] Entry (0x00007f89cc774758) is not buffering
14:12:27.735 I [audio_streamer.cpp:981          ] Encrypted data 64k-latency: 192 ms. Play latency: 183 ms
14:12:27.736 D [gaia_manager.cpp:874            ] GAIA:   current state ID updated to -1745951185
14:12:27.766 I [request_accounting.cpp:416      ] High request latency: https://heads-fa.scdn.co/head took 223 ms
14:12:27.889 I [request_accounting.cpp:416      ] High request latency: https://spclient.wg.spotify.com/ad-logic took 352 ms
14:12:27.943 D [gaia_manager.cpp:954            ] GAIA: GaiaManager::notifyCurrentState: states differ
14:12:32.561 I [sliding_window_prefetch_strategy.cpp:181] Prefetch: start prefetching track  Sidewalk Soul : 7ebcf1fd5cf98e601f67a9a3571b7a2090016935
```

In all cases of failed playback, we can obsereve these messages:

```
14:12:27.568 I [connectivity_manager.cpp:102    ] Emitting signal.
14:12:27.589 E [dial_discovery.cpp:413          ] Operation canceled
14:12:27.589 E [dial_discovery.cpp:413          ] Operation canceled
```

Currently I see no realtion.




# Out of memory issue

Spotify may occasionnaly crash and report error "Fatal error: out of memory".





