# Flatpak Steam application and games testing report

Fisrt part is related to Steam issues, second to Steam Games

# Steam Issues

## [DON'T WORK] Steam - com.valvesoftware.Steam

One useful link: `https://wiki.archlinux.org/index.php/Steam/Troubleshooting`

Numerous issues:
  - pulseaudio error for mic
  - [1105/102624.534867:ERROR:sandbox_linux.cc(369)] InitializeSandbox() called with multiple threads in process gpu-process. => same kind of error as chrome, they use the same component
  - Fatal : VkResult is "ERROR_INITIALIZATION_FAILED" in /home/pgriffais/src/Vulkan/base/vulkanexamplebase.cpp at line 823
vulkandriverquery: /home/pgriffais/src/Vulkan/base/vulkanexamplebase.cpp:823: void VulkanExampleBase::initVulkan()
  - game could not be stopped form stram, STOP button won't work
  - steam uses systray for game icons, we don't have it, so once we quit game window, we can't re-enter, so game needs to be killed manually, before we can log off and quit steam
  - known steam issues with flatpak: `https://wiki.archlinux.org/index.php/Steam`

  - have seen one segfault, while starting up:

```
crash_20191107155101_1.dmp[219]: Uploading dump (out-of-process)
/tmp/dumps/crash_20191107155101_1.dmp
/home/jerry/.local/share/Steam/steam.sh: line 720:   140 Segmentation fault      $STEAM_DEBUGGER "$STEAMROOT/$STEAMEXEPATH" "$@"
[1107/155102.513963:INFO:crash_reporting.cc(247)] Crash reporting enabled for process: browser
[1107/155102.545712:WARNING:crash_reporting.cc(286)] Failed to set crash key: UserID with value: 0
[1107/155102.545800:WARNING:crash_reporting.cc(286)] Failed to set crash key: BuildID with value: 1573010005
[1107/155102.545804:WARNING:crash_reporting.cc(286)] Failed to set crash key: SteamUniverse with value: Public
[1107/155102.545807:WARNING:crash_reporting.cc(286)] Failed to set crash key: Vendor with value: Valve
[1107/155102.601837:WARNING:crash_reporting.cc(286)] Failed to set crash key: UserID with value: 0
[1107/155102.601901:WARNING:crash_reporting.cc(286)] Failed to set crash key: BuildID with value: 1573010005
[1107/155102.601904:WARNING:crash_reporting.cc(286)] Failed to set crash key: SteamUniverse with value: Public
[1107/155102.601907:WARNING:crash_reporting.cc(286)] Failed to set crash key: Vendor with value: Valve
[1107/155102.605735:INFO:crash_reporting.cc(247)] Crash reporting enabled for process: gpu-process
[1107/155102.723532:ERROR:sandbox_linux.cc(369)] InitializeSandbox() called with multiple threads in process gpu-process.
[1107/155102.784295:WARNING:crash_reporting.cc(286)] Failed to set crash key: UserID with value: 0
[1107/155102.784421:WARNING:crash_reporting.cc(286)] Failed to set crash key: BuildID with value: 1573010005
[1107/155102.784430:WARNING:crash_reporting.cc(286)] Failed to set crash key: SteamUniverse with value: Public
[1107/155102.784437:WARNING:crash_reporting.cc(286)] Failed to set crash key: Vendor with value: Valve
[1107/155102.790959:INFO:crash_reporting.cc(247)] Crash reporting enabled for process: utility
crash_20191107155101_1.dmp[219]: Finished uploading minidump (out-of-process): success = yes
crash_20191107155101_1.dmp[219]: response: CrashID=bp-d37e352c-132b-412e-a55a-b311d2191107
crash_20191107155101_1.dmp[219]: file ''/tmp/dumps/crash_20191107155101_1.dmp'', upload yes: ''CrashID=bp-d37e352c-132b-412e-a55a-b311d2191107''
```

Simply reinstalling steam (with flatpak uninstall and install) , won't solve this issue. flatpak will reinstall `/home/varflatpak/lib/flatpak/app/com.valvesoftware.Steam/` contents, which is steam base installation. Steam keeps it's own runtime inside `/home/jerry/.var/app/com.valvesoftware.Steam` and this is where the problem is. Note that this folder  get's mounted by flatpak, as user $HOME inside isolated namespaces.

So we have to delete `/home/jerry/.var/app/com.valvesoftware.Steam` and to run steam again, which will say something like "pins are outdated" and will start normally.

## Audio issues

Steam needs both 32-bit and 64-bit support, and we provide ALSA and SDL2 runtime fixes in both options, so audio playback shall be fine

NOTE: Steam provides it's own runtimes, called "ubuntu12_32", which has it's own versions of ALSA and SDL2 libs. 

### Steam runtimes paths inside flatpak hutch:

`home/me/.var/app/com.valvesoftware.Steam/.local/share/Steam/ubuntu12_32/steam-runtime/usr/lib/i386-linux-gnu`

`home/me/.var/app/com.valvesoftware.Steam/.local/share/Steam/ubuntu12_32/steam-runtime/usr/lib/x86_64-linux-gnu`

NOTE: this is full path on Axiom host:

`/home/jerry/.opt/hutches/flatpak/filesystem layout/home/me/.var/app/com.valvesoftware.Steam/.local/share/Steam/ubuntu12_32/steam-runtime/usr/lib/`


### Steam runtimes inside Steam sandbox:

```
./home/me/.local/share/Steam/ubuntu12_32/steam-runtime/usr/lib/i386-linux-gnu/libasound.so.2.0.0
./home/me/.local/share/Steam/ubuntu12_32/steam-runtime/usr/lib/x86_64-linux-gnu/libasound.so.2.0.0
./var/data/Steam/ubuntu12_32/steam-runtime/usr/lib/i386-linux-gnu/libasound.so.2.0.0
./var/data/Steam/ubuntu12_32/steam-runtime/usr/lib/x86_64-linux-gnu/libasound.so.2.0.
```

It's known that this version of ALSA is compiled without support for essential plugins used by Axiom configuration. And SLD2 is compiled without ALSA support, so in general, if games insist to use steam runtimes, this will lead to audio issues.


## Games

### [WORKS] AdVenture Capitalist

### [WORKS] Mission Zigloton

### [WORKS] Super Bernie World

### [WORKS] Super Crate Box

### [DON'T WORK] Sono

Trying to run the game returns:

```
Opted-in Controller Mask for AppId 1218260: 0
Game update: AppID 1218260 "", ProcID 417, IP 0.0.0.0:0
Starting app 1218260
>>> Adding process 417 for game ID 1218260
GameAction [AppID 1218260, ActionID 2] : LaunchApp changed task to WaitingGameWindow with ""
ERROR: ld.so: object '/home/me/.local/share/Steam/ubuntu12_32/gameoverlayrenderer.so' from LD_PRELOAD cannot be preloaded (wrong ELF class: ELFCLASS32): ignored.
GameAction [AppID 1218260, ActionID 2] : LaunchApp changed task to Completed with ""
ERROR: ld.so: object '/home/me/.local/share/Steam/ubuntu12_32/gameoverlayrenderer.so' from LD_PRELOAD cannot be preloaded (wrong ELF class: ELFCLASS32): ignored.
>>> Adding process 418 for game ID 1218260
Found path: /home/me/.local/share/Steam/steamapps/common/Sono/Sono.x86_64
Game removed: AppID 1218260 "", ProcID 417 
Uploaded AppInterfaceStats to Steam
Exiting app 1218260

```

### [DON'T WORK] Legend of Keepers

```
Installing breakpad exception handler for appid(gameoverlayui)/version(1.0)
[0404/140316.493765:INFO:crash_reporting.cc(270)] Crash reporting enabled for process: renderer
Installing breakpad exception handler for appid(gameoverlayui)/version(1.0)
[0404/140316.767740:ERROR:frame_sink_video_capturer_impl.cc(206)] Invalid resolutions constraints: 0x0 must not be greater than 0x0; and also within media::limits.
Stacktrace:


Native stacktrace:

	/home/me/.local/share/Steam/steamapps/common/Legend of Keepers Prologue/LegendOfKeepersPrologue_Data/Mono/x86_64/libmono.so(+0x987d3) [0x7f904a8247d3]
	/usr/lib/x86_64-linux-gnu/libpthread.so.0(+0x13ae0) [0x7f90513c2ae0]
	/usr/lib/x86_64-linux-gnu/libc.so.6(gsignal+0x145) [0x7f905121f605]
	/usr/lib/x86_64-linux-gnu/libc.so.6(abort+0x12b) [0x7f9051208899]
	/home/me/.local/share/Steam/steamapps/common/Legend of Keepers Prologue/LegendOfKeepersPrologue.x86_64() [0xd2cb66]
	/home/me/.local/share/Steam/steamapps/common/Legend of Keepers Prologue/LegendOfKeepersPrologue_Data/Mono/x86_64/libmono.so(+0xd90cd) [0x7f904a8650cd]
	/home/me/.local/share/Steam/steamapps/common/Legend of Keepers Prologue/LegendOfKeepersPrologue_Data/Mono/x86_64/libmono.so(+0x3737f) [0x7f904a7c337f]
	/usr/lib/x86_64-linux-gnu/libpthread.so.0(+0x13ae0) [0x7f90513c2ae0]
	/usr/lib/x86_64-linux-gnu/libstdc++.so.6(_ZTVN10__cxxabiv120__si_class_type_infoE+0x10) [0x7f9051729d98]

Debug info from gdb:


=================================================================
Got a SIGABRT while executing native code. This usually indicates
a fatal error in the mono runtime or one of the native libraries 
used by your application.
=================================================================
```
