# xdg-desktop-portal

This package provides desktop integration brigde between flatpak sandboxed applications and host desktop environment. It uses DBUS as IPC. More details availalbe at:

  * [https://github.com/flatpak/xdg-desktop-portal]
  * [https://flatpak.github.io/xdg-desktop-portal/portal-docs.html]

Running on Axiom, it is intended to be used only in flatpak hutch, providing integration between flatpak apps and Axiom host.

Original source code is being patched to redirect all available DBus portal interface handlers, to Axiom specific implementation. Instead of standard installation, we just provide portal executable in `flatpak/bin` and a symlink in `/bin`.Portal executable is renamed to `xdg-desktop-portal-axiom`

Patches are available in `runtime utilities/xdg-desktop-portal-axiom`:

  - `Makefile.in.patch` - provide two new source files, where we implement Axiom specific handlers: `axiom-impl.c` and `axiom-impl.h`
  - `xdg-desktop-portal-axiom.patch` - provide redirection of all available DBus portal interface handlers. 
  
NOTE: Second patch eliminate need for backend portal implementations (gtk and kde). `xdg-desktop-portal` is originally designed in modular way, with backend implementations provided as separate build projects: `xdg-desktop-portal-gtk` and `xdg-desktop-portal-kde`.

Since `xdg-desktop-portal-gtk` depends on gtk 3.20, we had to avoid it, and force loading of all available interfaces, even if backend implementation is not available.


## How to run xdg-desktop-portal in flatpak hutch

This is just a guideline on how to write `run.sh` application startup wrapper.

```
export XDG_DATA_DIRS=/opt/gsettings-desktop-schemas-3.20.0/s
export $(dbus-launch)
xdg-desktop-portal-axiom -v > portal.log
```

