#include <SDL2/SDL.h>
#include "sdl2_audio_api.h"

/* for flatpak runtime build with: gcc -o sdl2_test sdl2_audio_api.c sdl2_test.c -lSDL2 */
/* for Axiom tests: TODO if we ever need it */

/* usage: ./sdl2_test soundfile.wav */


int main(int argc, char *argv[])
{
	if (argc != 2)
	{
		printf("Usage: ./sdl2_test soundfile\n");
		return -1;
	}
	
	// Initialize SDL2 Audio only
	SDL_Init(SDL_INIT_AUDIO);
	
	// Initialize Simple-SDL2-Audio
	initAudio();
	
	// Play test sound
	printf("Playing test sound: %s\n", argv[1]);
	playSound(argv[1], SDL_MIX_MAXVOLUME / 2);
	
	/* this is quite ugla way to wait until audio stop playing */
	/* seems there is no easy way to find out when audio file ends up playing */
	/* so we play it 3s for now */
	/* TODO: there must be a callback when SDL2 reach endo of the audio file */
	SDL_Delay(3000);
	
	// End Simple-SDL2-Audio
	endAudio();
	
	// End SDL2
	SDL_Quit();
}
