package_name="ghostscript"
package_version="9.22"
tarball_suffix=gz
build_dependencies="zlib jpeg cups"


custombuild() {
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory
	
	
	sed -i 's/AUXEXTRALIBS=@AUXEXTRALIBS@ @AUX_SHARED_ZLIB@/AUXEXTRALIBS=@AUXEXTRALIBS@ @AUX_SHARED_ZLIB@ -Wl,-rpath,\/opt\/fontconfig\/lib -Wl,-rpath,\/opt\/freetype\/lib/g' Makefile.in
	CPPFLAGS="-I/opt/zlib/include \
		-I/opt/jpeg/include \
		-I/opt/cups/include \
		" \
	LDFLAGS="-Wl,-rpath,/opt/fontconfig/lib \
		-Wl,-rpath,/opt/freetype/lib \
		-L/opt/zlib/lib \
		-Wl,-rpath,/opt/zlib/lib \
		-L/opt/jpeg/lib \
		-Wl,-rpath,/opt/jpeg/lib \
		-L/opt/cups/lib \
		-Wl,-rpath,/opt/cups/lib \
		" \
	./configure --prefix=/opt/$package_name-$package_version

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	make install

	ln -snv $installdirectory/$package_fullname $installdirectory/$package_name || true   # if $package_name already exists (for example, another version is already installed), don't overwrite, and don't crash
	ln -sv $installdirectory/$package_name/bin/* $bindirectory || true   # don't crash if the links are already there
	if [ -d "$installdirectory/$package_fullname/lib/pkgconfig" ]; then
		ln -svf $installdirectory/$package_fullname/lib/pkgconfig/* $installdirectory/pkgconf/lib/pkgconfig/   # symlink pkg-config files
	fi

	cd ../..
	rm -r $builddir
}
