package_name=gtk+
package_version=3.22.29
build_dependencies="glib-2.49.7 libepoxy atk gdk-pixbuf pango at-spi2-atk"   # glib 2.49.7 is the minimum version, but we can also use higher versions
tarball_suffix=xz
no_check=1

########################
#
# GTK+3
#
# GTK (Gimp Graphical Toolkit) is a graphical toolkit
# 
##########################


# NOTE: when running gtk programs, some runtime paths will be needed. So link with "-Wl,-rpath=/opt/gtk+/lib -Wl,-rpath=/opt/atk/lib -Wl,-rpath=/opt/cairo/lib -Wl,-rpath=/opt/gdk-pixbuf/lib -Wl,-rpath=/opt/pango/lib -Wl,-rpath=/opt/glib/lib -Wl,-rpath=/opt/fontconfig/lib -Wl,-rpath=/opt/freetype/lib". When compiling and linking, also provide `pkg-config --cflags --libs gtk+-3.0`



# TODO: tests fail, fix
# TODO: try to patch configure or whatever is broken

# custombuild because bug in configure (incorrect linking of glib)
custombuild(){
	rm -rf builddir
	mkdir -p builddir   # do everything in builddir for tidiness
	cd builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory

	# gtk will prevent suid apps to run, but will allow root to run, so it's a bug
	# remove check for suid/sgid
	cd gtk/
	#patch < ../../../packages/base/gtk+2-suid.patch
	cd ../

	export CPPFLAGS="-I/opt/cairo/include"
	LDFLAGS="-Wl,-rpath=$installdirectory/glib/lib" ./configure --prefix=$installdirectory/$package_fullname/   # bug in configure
	
	
	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	if test -z $no_check   # run the make check, unless $no_check is set for this package definition
	then make -j check || make -j test
	fi
	make install
	ln -snv $installdirectory/$package_fullname $installdirectory/$package_name
	ln -sv $installdirectory/$package_name/bin/* /bin/ || true   # don't crash if the links are already there
	if [ -d "$installdirectory/$package_name/lib/pkgconfig" ]; then
		ln -svf $installdirectory/$package_name/lib/pkgconfig/* \
		$installdirectory/pkgconf/lib/pkgconfig/   # install pkg-config files
	fi
	cd ../..
	rm -r builddir
}

postinstall(){

        # remove docs
        rm -r $installdirectory/$package_fullname/share/gtk-doc
        
        # strip
        strip $installdirectory/$package_fullname/lib/* || true
}
