package_name=linux-kernel
package_version=5.17-rc5
tarball_suffix=gz
build_dependencies="make elfutils linux-kernel-headers bc openssl"


custombuild() {
	
	# clean up first, in case we are running this script manually and there are leftovers
	rm -rf $KERNEL_BUILD_DIR

	mkdir -p $KERNEL_BUILD_DIR
	cd $KERNEL_BUILD_DIR


	######################
	#
	# Build
	#
	######################


	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory
	
	cp linux-kernel/axiom-generic-config.config .config




	# NOTES:
	# - some kernel version between 5.9 and 5.15 forces CONFIG_STACK_VALIDATION, which in turns forces to build objtool, which is annoying to build
	# - some build tools are using OpenSSL, caused by the default activation of CONFIG_CFG80211_REQUIRE_SIGNED_REGDB in the kernel config, which triggers a cascade of dependencies until CONFIG_SYSTEM_TRUSTED_KEYRING, when updating from kernel 4.14 -> 4.15
	
	# NOTE: initramfs needed, can use the one on the rootfs in /opt/initramfs


	make olddefconfig
	
	# these 2 libraries won't be found otherwise
	export LD_LIBRARY_PATH=/opt/elfutils/lib:/opt/libressl/lib
	
	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu

	
	
}

