package_name="lm-sensors"
package_version="3-6-0"
tarball_suffix=gz
build_dependencies="bison flex"


custombuild() {
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu PREFIX=/opt/$package_fullname
	find ./ -exec sed -i 's/\/usr\/bin/\/bin/' {} \;
	find ./ -exec sed -i 's/\/usr\/sbin/\/bin/' {} \;
	make install PREFIX=/opt/$package_fullname

	ln -sv /opt/$package_name-$package_version /opt/$package_name || true
	ln -sv /opt/$package_name-$package_version/bin/* /bin/ || true

	if [ -d "/opt/$package_name-$package_version/lib/pkgconfig" ]; then
		ln -svf /opt/$package_name-$package_version/lib/pkgconfig/* /opt/pkgconf/lib/pkgconfig
	fi

	cd ../..
	rm -r $builddir
}

postinstall() {
	ln -svf /opt/$package_name/sbin/* /bin/
}
