package_name=metacity
package_version=2.34.13
tarball_suffix=xz
build_dependencies="libxslt itstool gnome-doc-utils gsettings-desktop-schemas gtk+2"



# TODO: it seems that metacity needs /opt/gnome-doc-utils/lib/python2.7/site-packages/xml2po
#       but metacity runs fine if we remove Python, so i'm not sure how it needs it. Maybe it's needed only at compile time 


custombuild(){
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url   # TODO: verify that the archive has not been tempered by calculating and checking a cryptographic hash of it
	tar xvf archive
	rm archive
	cd *   # cd into the package directory



	sed -i 's/\#include <math.h>/\#include <math.h>\n\n\#define M_PI 3.14159265/g' src/ui/theme.c

	# patch to launch screenshot program
	patch -p1 < ../../packages/extended/metacity/metacity-printscreenshot.patch

	# patch configure to remove zenity
	patch -p1 < ../../packages/extended/metacity/metacity-nozenity.patch

	# patch configure to fix X detection
	patch < ../../packages/extended/metacity/metacity-configure.patch

	# metacity should retry to open display to not to fail if X had been started later
	patch -p1 < ../../packages/extended/metacity/metacity-loop-x-connection.patch

	# fix bug, when metacity kills itself by calling kill(0,9). This had happend due to missing zenity
	patch -p1 < ../../packages/extended/metacity/metacity-dont-kill-itself.patch

	autoconf  # because we patched configure
	./configure --prefix=$installdirectory/$package_fullname/ --disable-startup-notification --disable-sm --x-includes=/opt/xorg-X11R7.7/include --x-libraries=/opt/xorg-X11R7.7/lib --disable-canberra --datadir=/opt/gsettings-desktop-schemas/share

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	make install

	ln -snv $installdirectory/$package_fullname $installdirectory/$package_name || true   # if $package_name already exists (for example, another version is already installed), don't overwrite, and don't crash
	ln -sv $installdirectory/$package_name/bin/* $bindirectory || true   # don't crash if the links are already there
	
	
	cd ../..
	rm -r $builddir

	# move Alt-tab binding from "switch-applications" (which is not handled by metacity) to "switch-windows" (which is)
	# and adding of 'print-screenshot'
	patch -p0 < packages/extended/metacity/metacity-keybinding.patch
	# rebuild schema with new bindings
	glib-compile-schemas /opt/gsettings-desktop-schemas/share/glib-2.0/schemas



}
