package_name=ntfs-3g
package_version=2017.3.23
tarball_suffix=gz
build_dependencies=


# This is a custom build, beecause we need only ntfs-3g driver, built statically, to be able to mount ntfs partitions r/w. This is done to avoid installng unecessary stuff

# For development purposes, set full_build=true, to enable full package build
full_build=false
# TODO: we can decide to install full ntfs-3g suite, but it may bloat Axiom system 


custombuild(){
	rm -rf builddir
	mkdir -p builddir
	cd builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *

	# enable fully static build, to avoid placing shared libs in /lib
	./configure --prefix=$installdirectory/$package_fullname --enable-really-static

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu

	if [ "$full_build" = "true" ]; then
		make install

		ln -sv $installdirectory/$package_fullname $installdirectory/$package_name
		ln -sv $installdirectory/$package_name/bin/* /bin/ || true
		ln -sv $installdirectory/$package_name/sbin/* /bin/ || true
		if [ -d "$installdirectory/$package_name/lib/pkgconfig" ]; then
			ln -svf $installdirectory/$package_name/lib/pkgconfig/* \
			$installdirectory/pkgconf/lib/pkgconfig/
		fi
	else
		# install just binary driver
		mkdir -p $installdirectory/$package_fullname/bin
		ln -sv $installdirectory/$package_fullname $installdirectory/$package_name
		cp -f src/ntfs-3g $installdirectory/$package_fullname/bin
		ln -sv $installdirectory/$package_fullname/bin/* /bin/ || true
	fi

	cd ../..
	rm -r builddir

}
