# IMPORTANT NOTE: about openvpn usage on Axiom. We need to run it in several steps:
#  1. Login as root (use su)
#  2. In your config.ovpn file (wherever you got it from), comment line with "dev tun"
#  3. modprobe tun
#  4. openvpn --mktun --dev tun0
#  5. openvpn --dev tun0 --config openvpnconfig.ovpn

# TODO: openvpn shall work normally with automatically choosen tun device, find culprit

package_name="openvpn"
package_version="2.4.8"  # requires libressl-2.9.1, openvnp-2.4.6 builds with libressl-2.3.4
tarball_suffix=gz
buildependencies="libressl-2.9.1"


custombuild(){
	builddir="builddir-$package_fullname"  # build directory is "builddir" followed by the name of the package, which allows multiple builds of different software in parallel
	rm -rf $builddir
	mkdir -p $builddir   # do everything in builddir for tidiness
	cd $builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory

	./configure --prefix=/opt/$package_name-$package_version --disable-lzo --disable-plugin-auth-pam

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	make install

	ln -sv /opt/$package_name-$package_version /opt/$package_name || true
	ln -sv /opt/$package_name-$package_version/sbin/* /bin/ || true

	if [ -d "/opt/$package_name-$package_version/lib/pkgconfig" ]; then
		ln -svf /opt/$package_name-$package_version/lib/pkgconfig/* /opt/pkgconf/lib/pkgconfig
	fi

	cd ../..
	rm -r $builddir
}
