package_name=parted
package_version=3.2
tarball_suffix=xz
build_dependencies="ncurses libuuid linux-kernel-headers"
no_check=1 

custombuild(){


	mkdir build
	cd build

	wget http://mirrors.tassig.com/parted/parted-3.2.tar.xz
	tar xvf parted-3.2.tar.xz
	cd parted-3.2
	
	export CPPFLAGS="-I/opt/libuuid/include/" 
	export LDFLAGS="-L/opt/libuuid/lib/" 
	./configure --prefix=/opt/parted-3.2 --disable-device-mapper --without-readline

	# parted-3.2 device-mapper is disabled but still some defines are not guarded with ifdefs
	patch -p0 < ../../packages/extended/parted/parted-3.2.patch

	# musl related issue, loff_t is not provided, we have to workaround
	# allow static linking with libparted, still parted will be dynamically linked with libc and libuuid TODO: would be nice to link statically, we don't know how to do it easily here
	make -j4 CFLAGS="-static -Dloff_t=off_t" -j4   # NOTE: the environment variables seem to be ignored with make, only passing as arguments work, which is weird

	# quickly workaround to link partprobe statically, until we find a way to do it for whole parted package
	cd partprobe
	rm -r partprobe
	gcc -static -I../lib -I../include -g -O2 -o partprobe partprobe.c ../libparted/.libs/libparted.a /opt/libuuid/lib/libuuid.a 
	cd ../

	#make check   TODO: one test fails, investigate
	make install

	ln -sv /opt/parted-3.2 /opt/parted
	ln -sv /opt/parted/sbin/* /bin/ || true

	# Clean up
	cd ../..
	rm -r build/
}


