package_name=pulseaudio
package_version=13.99.1
tarball_suffix=gz
build_dependencies="gettext-0.19.8 libcap libsndfile intltool gsettings-desktop-schemas alsa-lib"
no_check=1 

custombuild(){
	rm -rf builddir
	mkdir -p builddir   # do everything in builddir for tidiness
	cd builddir
	wget -O archive $url
	tar xvf archive
	rm archive
	cd *   # cd into the package directory

	find ./ -name '*.sh' -exec sed -i 's/#!\/usr\/bin\/env /#!\/bin\//' {} \;
	find ./ -name '*.sh' -exec sed -i 's/#!\/bin\/bash/#!\/bin\/sh/' {} \;
	echo $package_version > .tarball-version # autogen will require this file
	CFLAGS="-I/opt/libtool/include \
		-I/opt/libcap/include" \
	LDFLAGS="-L/opt/libtool/lib -Wl,-rpath,/opt/libtool/lib \
		-L/opt/libcap/lib -Wl,-rpath,/opt/libcap/lib" \
		./autogen.sh \
			--prefix=$installdirectory/$package_fullname \
			--disable-manpages

	# NOTE: we have one warrning after configure:
	# Mismatches between the target platform and the to
	# be used libraries have been been detected for: libgpg-error

	make -j
	if test -z $no_check   # run the make check, unless $no_check is set for 
						   # this package definition
	then make -j check || make -j test
	fi

	make install

	ln -sv $installdirectory/$package_fullname $installdirectory/$package_name
	ln -sv $installdirectory/$package_name/bin/* /bin/ || true
	if [ -d "$installdirectory/$package_name/lib/pkgconfig" ]; then
		ln -svf $installdirectory/$package_name/lib/pkgconfig/* \
		$installdirectory/pkgconf/lib/pkgconfig/
	fi
	cd ../..
	rm -r builddir

}

postinstall(){
	cat <<EOF>/opt/pulseaudio/etc/pulse/default.pa
.fail
    # Set tsched=0 here if you experience glitchy playback. This will
    # revert back to interrupt-based scheduling and should fix it.
    #
    # Replace the device= part if you want pulse to use a specific device
    # such as "dmix" and "dsnoop" so it doesn't lock an hw: device.
    
    # INPUT/RECORD
    load-module module-alsa-source device="default" tsched=1
    
    # OUTPUT/PLAYBACK
    load-module module-alsa-sink device="default" tsched=1 
    
    # Accept clients -- very important
    load-module module-native-protocol-unix

.nofail
EOF

	sed -i 's/; autospawn =/autospawn =/' /opt/pulseaudio/etc/pulse/client.conf
	sed -i 's/; exit-idle-time = 20/exit-idle-time = -1/' /opt/pulseaudio/etc/pulse/daemon.conf
	sed -i 's/; flat-volumes = no/flat-volumes = yes/' /opt/pulseaudio/etc/pulse/daemon.conf
}
