package_name=x264
package_version=latest
tarball_suffix=gz
build_dependencies="bash"
no_check=1




custombuild(){
	rm -rf builddir
	mkdir -p builddir   # do everything in builddir for tidiness
	cd builddir
	
	# NOTE: instead of the following standard download of a package, we get the latest from git, x264 does not produce packages
	#wget -O archive $url
	#tar xvf archive
	#rm archive
	
	# x264 configure script is written in bash, or rather, written by people who don't know anything else than bash, so there are some unintentional bash-isms
	# GIT_SSL_NO_VERIFY=1 is done because of some expired certificate
	GIT_SSL_NO_VERIFY=1 git clone https://code.videolan.org/videolan/x264.git
	
	
	cd *   # cd into the package directory


	# i added --disable-asm, i'm sure we could install nasm, but i'm also pretty sure that the people who wrote x264 are not better than GCC at generating assembly, so their "optimizations" are most likely overkill
	./configure --prefix=/opt/x264-$package_version --disable-asm --enable-shared --enable-static --disable-cli

	ncpu=`cat /proc/cpuinfo | grep processor | wc -l`
	make -j$ncpu
	make install


	ln -svf /opt/x264-$package_version /opt/x264
	ln -svf /opt/x264/lib/pkgconfig/*.pc /opt/pkgconf/lib/pkgconfig/


	cd ../..
	rm -r builddir
}
